//audio
datablock ParticleData(BlastRifleTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 0 0 0";
	colors[1]	= "1 0.5 0.5 0.20";
	colors[2]	= "1 1 1 0";
	sizes[0]	= 0.4;
	sizes[1]	= 0.2;
	sizes[2]	= 0.05;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(BlastRifleTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 2;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = BlastRifleTrailParticle;
};

datablock ParticleData(BlastRifleExplosionParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.25;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 750;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 5.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "0.9 0.5 0.0 0.7";
   colors[1]     = "0.4 0.4 0.4 0.3";
   colors[2]     = "0.9 0.9 0.9 0.1";

	sizes[0]	= 4.0;
	sizes[1]	= 3.0;
   sizes[2]	= 2.0;

	times[0]	= 0.0;
	times[1]	= 0.28;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(BlastRifleExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 90;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360; //180
   overrideAdvance = false;
   particles = "BlastRifleExplosionParticle";
};


datablock ParticleData(BlastRifleExplosionRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 10;
   textureName          = "base/data/particles/star1";
   spinSpeed        = 10.0;
   spinRandomMin        = -500.0;
   spinRandomMax        = 500.0;
   colors[0]     = "1.0 1.0 0.6 1";
   colors[1]     = "1.0 1.0 0.6 1";
   sizes[0]      = 6;
   sizes[1]      = 2;

   useInvAlpha = false;
};

datablock ParticleEmitterData(BlastRifleExplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 6;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BlastRifleExplosionRingParticle";
};

datablock ParticleData(BlastRifleExplosionRing2Particle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 135;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
   colors[0]     = "0.1 0.05 0.025 0.3";
   colors[1]     = "0.1 0.05 0.025 0.0";
	sizes[0]      = 4;
	sizes[1]      = 2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(BlastRifleExplosionRing2Emitter)
{
	lifeTimeMS = 90;

   ejectionPeriodMS = 6;
   periodVarianceMS = 0;
   ejectionVelocity = 11;
   velocityVariance = 1.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "BlastRifleExplosionRing2Particle";
};
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

datablock ExplosionData(BlastRifleExplosion)
{
   //explosionShape = "Add-Ons/Weapon_Rocket Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   soundProfile = ImpactGrenadeExplosionSound;
   
   emitter[0] = BlastRifleExplosionRingEmitter;
   emitter[1] = BlastRifleExplosionEmitter;
   emitter[2] = BlastRifleExplosionRing2Emitter;
   //emitter[1] = "";
   //emitter[2] = "";
   //emitter[0] = "";


   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 1;
   impulseForce = 100;

   damageRadius = 4;
   radiusDamage = 50;

//	uiName = "Impact Grenade Explosion";
};

AddDamageType("BlastRifle",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_BlastRifle> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_BlastRifle> %1',0.75,1);
AddDamageType("BlastRifleRadius",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_BlastRifleRadius> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_BlastRifleRadius> %1',0.75,1);
datablock ProjectileData(BlastRifleProjectile1)
{
   projectileShapeName = "./Slug.dts";
   directDamage        = 25;
   directDamageType = $DamageType::BlastRifle;
   radiusDamageType = $DamageType::BlastRifleRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = BlastRifleExplosion;
   particleEmitter     = BlastRifleTrailEmitter;
   
   brickExplosionRadius = 1;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 2;
   brickExplosionMaxVolume = 5;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 10;  //max volume of bricks that we can destroy if they aren't connected to the ground

//   impactImpulse	     = 20;
   verticalImpulse     = 10;
   explosion           = BlastRifleExplosion;

   muzzleVelocity      = 125;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.1;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "1 0 0";
};

//////////
// item //
//////////
datablock ItemData(BlastRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./BlastRifle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Blast Rifle";
	iconName = "./icon_BlastRifle";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = BlastRifleImage;
	canDrop = true;
	
	maxAmmo = 8;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BlastRifleImage)
{
   // Basic Item properties
   shapeFile = "./BlastRifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BlastRifleItem;
   ammo = " ";
   projectile = BlastRifleProjectile1;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 1.0 1.0"; //1.0 0.1 1.0
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = BlastRifleItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateSequence[0]		= "Activate";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ReloadStart";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateScript[1]                  = "onReady";
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.25;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= CombatRifleFireSound;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.25;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTriggerUp[3] = "Wait";

	stateName[4]			= "Wait";
	stateEjectShell[2]              = true;
	stateSequence[2]               = "flap";
	stateTimeoutValue[4]		= 0.25;
	stateTransitionOnTimeout[4]	= "LoadCheckA";
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ReloadStart";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 2.0;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "Reloaded";
	stateWaitForTimeout[8]			= true;
	
	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.3;
	stateScript[9]				= "onReloaded";
        stateTransitionOnTimeout[9]		= "Ready";
};

function BlastRifleImage::onReady(%this,%obj,%slot)
{
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Blast Rounds <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["BlastRounds"] @ "", 1, 2, 3, 4); 
}

function BlastRifleImage::onFire(%this,%obj,%slot)
{
	%projectile = BlastRifleProjectile1;
	
	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.00025; //0.0010
	}
	else
	{
		%spread = 0.001; //0.0050
	}
	
	%shellcount = 1;

	%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Blast Rounds <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["BlastRounds"] @ "", 4, 2, 3, 4); 

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function BlastRifleImage::onReloadStart(%this,%obj,%slot)
{
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Blast Rounds <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["BlastRounds"] @ "", 1, 2, 3, 4); 
    if(%obj.client.quantity["BlastRounds"] >= 1)
	{
	%obj.playThread(2, shiftUp);
            serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	}
}

function BlastRifleImage::onReloaded(%this,%obj,%slot)
{
    if(%obj.client.quantity["BlastRounds"] >= 1)
	{

	%obj.playThread(2, plant);
        if(%obj.client.quantity["BlastRounds"] > %this.item.maxAmmo)
	{
		%obj.client.quantity["BlastRounds"] -= %obj.AmmoSpent[%obj.currTool];
		%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
		%obj.AmmoSpent[%obj.currTool] = 0;
            serverPlay3D(FWReload1sound,%obj.getPosition());
		%obj.setImageAmmo(%slot,1);
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Blast Rounds <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["BlastRounds"] @ "", 1, 2, 3, 4); 
		return;
	}

        if(%obj.client.quantity["BlastRounds"] <= %this.item.maxAmmo)
	{
		%obj.client.exchangebullets = %obj.client.quantity["BlastRounds"];
		%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
		%obj.setImageAmmo(%slot,1);
            serverPlay3D(FWReload1sound,%obj.getPosition());
		%obj.client.quantity["BlastRounds"] = 0;
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Blast Rounds <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["BlastRounds"] @ "", 1, 2, 3, 4); 
		return;
	}
}
}

//statescript onBounce