datablock PlayerData(DeployedArmor : PlayerStandardArmor)
{
   runForce = 10000; //Huge number to prevent the player from sliding across the terrain like ice.
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 0; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "";
	showEnergyBar = false;

   runSurfaceAngle  = 55;
   jumpSurfaceAngle = 55;
};


AddDamageType("Vulcan",   '<bitmap:add-ons/Weapon_Frogs_Weaponry/CI_Vulcan> %1',    '%2 <bitmap:add-ons/Weapon_Frogs_Weaponry/CI_Vulcan> %1',0.75,1);
datablock ProjectileData(VulcanProjectile1)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 18;
   directDamageType    = $DamageType::Vulcan;
   radiusDamageType    = $DamageType::Vulcan;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 20;
   verticalImpulse     = 10;
   explosion           = gunExplosion;

   muzzleVelocity      = 120;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.7;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//////////
// item //
//////////
datablock ItemData(VulcanItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Vulcan.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Vulcan";
	iconName = "./icon_Vulcan";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = VulcanImage;
	canDrop = true;
	
	maxAmmo = 200;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(VulcanImage)
{
   // Basic Item properties
   shapeFile = "./Vulcan.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = VulcanItem;
   ammo = " ";
   projectile = VulcanProjectile1;
   projectileType = Projectile;

   casing = BigShellDebris;
   shellExitDir        = "0 1 -1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = VulcanItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.05;
	stateSequence[0]                  = "Activate";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateScript[1]                   = "OnReady";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "SpinUp";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0; //0.05
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateEjectShell[2]       	  = true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= "VulcanFireSound";

	stateName[3]			        = "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateSound[3]                   = "VulcanSpinSound";
    stateTimeoutValue[3]            = 0.05; //0.05
	stateSequence[3]                = "Firespin";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.03;
	stateEmitterNode[3]				= "muzzleNode";
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 3.5; //1.6
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	stateWaitForTimeout[6]			= true;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.8;
	stateScript[7]				= "onReloadWait";
    stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0; //0.01
	stateSound[8]                          = "VulcanSpinSound";
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	stateEmitter[10]			= gunSmokeEmitter;
	stateEmitterTime[10]			= 0.3;
	stateEmitterNode[10]			= "muzzleNode";
	stateTimeoutValue[10]			= 0.1; //0.25
    stateSequence[10]                   = "Firespin";
	stateTransitionOnTimeout[10]		= "Restore";
	stateTransitionOnTriggerDown[10]	= "Fire";
	stateSound[10]                          = "VulcanSpinSound";

	stateName[11] 				= "ReloadSmoke";
	stateEmitter[11]			= gunSmokeEmitter;
	stateEmitterTime[11]			= 0.85;
	stateEmitterNode[11]			= "muzzleNode";
	stateSound[11]                  = "VulcanWindDownSound";
	stateSequence[11]               = "WindDown";
	stateTimeoutValue[11]			= 1;
    stateTransitionOnTimeout[11]		= "Reload";

	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
    stateTransitionOnTimeout[12]		= "Ready";

	stateName[13]                           = "SpinUp";
	stateTimeoutValue[13]                   = 0.85;
	stateScript[13]                         = "onSpinUp";
	stateSequence[13]                       = "WindUp";
    stateSound[13]	                        = "VulcanWindUpSound";
    stateTransitionOnTimeout[13]            = "SpinCheck";

    stateName[14]                           = "SpinCheck";
    stateTransitionOnTriggerDown[14]        = "Fire";
    stateTransitionOnTriggerUp[14]          = "Restore";
	
	stateName[15]                          = "Restore";
	stateTimeoutValue[15]                  = 0.85;
	stateScript[15]                        = "onRestore";
	stateSequence[15]                      = "WindDown";
	stateSound[15]                         = "VulcanWindDownSound";
	stateTransitionOnTimeout[15]           = "LoadCheckA";
};

function VulcanImage::onFire(%this,%obj,%slot)
{
	%projectile = VulcanProjectile1;
	
	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0055; //0.0040
	}
	else
	{
		%spread = 0.0060; //0.0070
	}
	
	%shellcount = 1;

	%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function VulcanImage::onReloadStart(%this,%obj,%slot)
{           		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
    if(%obj.client.quantity["50Cal"] >= 1)
	{
	%obj.playThread(2, shiftRight);
            serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	}
}

function VulcanImage::onReloadWait(%this,%obj,%slot)
{
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
    if(%obj.client.quantity["50Cal"] >= 1)
	{
	%obj.playThread(2, plant);
            serverPlay3D(FWReload2Sound,%obj.getPosition());
	}
}

function VulcanImage::onReloaded(%this,%obj,%slot)
{
    if(%obj.client.quantity["50Cal"] >= 1)
	{

        if(%obj.client.quantity["50Cal"] > %this.item.maxAmmo)
	{
		%obj.client.quantity["50Cal"] -= %obj.AmmoSpent[%obj.currTool];
		%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
		%obj.AmmoSpent[%obj.currTool] = 0;
		%obj.setImageAmmo(%slot,1);
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
		return;
	}

        if(%obj.client.quantity["50Cal"] <= %this.item.maxAmmo)
	{
		%obj.client.exchangebullets = %obj.client.quantity["50Cal"];
		%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
		%obj.setImageAmmo(%slot,1);
		%obj.client.quantity["50Cal"] = 0;
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
		return;
	}
}
}

function VulcanProjectile1::damage(%this,%obj,%col,%fade,%pos,%normal)
{
   if(%col.getType() & $TypeMasks::PlayerObjectType)
   {
      %col.setVelocity(getWord(%col.getVelocity(),0)/1.2 SPC getWord(%col.getVelocity(),1)/1.2 SPC getWord(%col.getVelocity(),1.2));
   }
parent::damage(%this,%obj,%col,%fade,%pos,%normal);
}

function VulcanImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
}

function VulcanImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
	%obj.popDatablock(SlowedArmor.getID());
}

function VulcanImage::onSpinUp(%this,%obj,%slot)
{
 	%obj.pushDatablock(SlowedArmor.getID());
}

function VulcanImage::onRestore(%this,%obj,%slot)
{
 	%obj.popDatablock(SlowedArmor.getID());
}

datablock ShapeBaseImageData(VulcanDeployedImage)
{
   // Basic Item properties
   shapeFile = "./VulcanDeployed.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0"; //0 0 0
   eyeOffset = "0 1.2 -0.8"; //"0.7 1.2 -0.5"; "0"
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = VulcanItem;
   ammo = " ";
   projectile = VulcanProjectile1;
   projectileType = Projectile;

   casing = BigShellDebris;
   shellExitDir        = "0 1 -1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   LarmReady = true;

   doColorShift = true;
   colorShiftColor = VulcanItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.05;
	stateSequence[0]                  = "Activate";
	stateTransitionOnTimeout[0]       = "DeployDelay";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateScript[1]                   = "OnReady";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "SpinUp";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0; //0.05
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateEjectShell[2]       	  = true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= "VulcanFireSound";

	stateName[3]			        = "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateSound[3]                   = "VulcanSpinSound";
    stateTimeoutValue[3]            = 0.05; //0.05
	stateSequence[3]                = "Firespin";
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.03;
	stateEmitterNode[3]				= "muzzleNode";
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 3.5; //1.6
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	stateWaitForTimeout[6]			= true;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.8;
	stateScript[7]				= "onReloadWait";
    stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0; //0.01
	stateSound[8]                          = "VulcanSpinSound";
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	stateEmitter[10]			= gunSmokeEmitter;
	stateEmitterTime[10]			= 0.3;
	stateEmitterNode[10]			= "muzzleNode";
	stateTimeoutValue[10]			= 0.1; //0.25
    stateSequence[10]                   = "Firespin";
	stateTransitionOnTimeout[10]		= "Restore";
	stateTransitionOnTriggerDown[10]	= "Fire";
	stateSound[10]                          = "VulcanSpinSound";

	stateName[11] 				= "ReloadSmoke";
	stateEmitter[11]			= gunSmokeEmitter;
	stateEmitterTime[11]			= 0.85;
	stateEmitterNode[11]			= "muzzleNode";
	stateSound[11]                  = "VulcanWindDownSound";
	stateSequence[11]               = "WindDown";
	stateTimeoutValue[11]			= 1;
    stateTransitionOnTimeout[11]		= "Reload";

	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
    stateTransitionOnTimeout[12]		= "Ready";

	stateName[13]                           = "SpinUp";
	stateTimeoutValue[13]                   = 0.85;
	stateScript[13]                         = "onSpinUp";
	stateSequence[13]                       = "WindUp";
    stateSound[13]	                        = "VulcanWindUpSound";
    stateTransitionOnTimeout[13]            = "SpinCheck";

    stateName[14]                           = "SpinCheck";
    stateTransitionOnTriggerDown[14]        = "Fire";
    stateTransitionOnTriggerUp[14]          = "Restore";
	
	stateName[15]                          = "Restore";
	stateTimeoutValue[15]                  = 0.85;
	stateScript[15]                        = "onRestore";
	stateSequence[15]                      = "WindDown";
	stateSound[15]                         = "VulcanWindDownSound";
	stateTransitionOnTimeout[15]           = "LoadCheckA";
	
	stateName[16]                          = "DeployDelay";
	stateTimeoutValue[16]                  = 1.5;
	stateTransitionOnTimeout[16]           = "DeployDelayEnd";
	
	stateName[17]                          = "DeployDelayEnd";
	stateTimeoutvalue[17]                  = 0.01;
	stateTransitiononTimeout[17]           = "LoadcheckA";
    stateScript[17]                        = "onDeployDelayEnd";
};

function VulcanDeployedImage::onFire(%this,%obj,%slot)
{
	%projectile = VulcanProjectile1;
	
	if(vectorLen(%obj.getVelocity()) < 0.1)
	{
		%spread = 0.0030; //0.0040
	}
	else
	{
		%spread = 0.0030; //0.0070
	}
	
	%shellcount = 1;

	%obj.playThread(2, plant);
	%shellcount = 1;
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

	%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}
function VulcanDeployedImage::onReloadStart(%this,%obj,%slot)
{           		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
    if(%obj.client.quantity["50Cal"] >= 1)
	{
	%obj.playThread(2, Plant);
            serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	}
}

function VulcanDeployedImage::onReloadWait(%this,%obj,%slot)
{
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
    if(%obj.client.quantity["50Cal"] >= 1)
	{
	%obj.playThread(2, plant);
            serverPlay3D(FWReload2Sound,%obj.getPosition());
	}
}

function VulcanDeployedImage::onReloaded(%this,%obj,%slot)
{
    if(%obj.client.quantity["50Cal"] >= 1)
	{

        if(%obj.client.quantity["50Cal"] > %this.item.maxAmmo)
	{
		%obj.client.quantity["50Cal"] -= %obj.AmmoSpent[%obj.currTool];
		%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
		%obj.AmmoSpent[%obj.currTool] = 0;
		%obj.setImageAmmo(%slot,1);
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
		return;
	}

        if(%obj.client.quantity["50Cal"] <= %this.item.maxAmmo)
	{
		%obj.client.exchangebullets = %obj.client.quantity["50Cal"];
		%obj.toolAmmo[%obj.currTool] = %obj.client.exchangebullets;
		%obj.setImageAmmo(%slot,1);
		%obj.client.quantity["50Cal"] = 0;
            		commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
		return;
	}
}
}

function VulcanDeployedImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
commandToClient(%obj.client,'bottomPrint',"<just:right><font:impact:24><color:fff000>.50 Caliber <font:impact:34>\c6" @ %obj.toolAmmo[%obj.currTool] @ " / " @ %obj.client.quantity["50Cal"] @ "", 4, 2, 3, 4); 
	%obj.pushDatablock(DeployedArmor.getID());
	%obj.playThread(2, ArmReadyBoth);
}

function VulcanDeployedImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
	%obj.popDatablock(DeployedArmor.getID());
}

function VulcanDeployedImage::onReady(%this,%obj,%slot)
{
	%obj.playThread(2, ArmReadyBoth);
}

function VulcanDeployedImage::onDeployDelayEnd(%this,%obj,%slot)
{
	%obj.playThread(2, Plant);
	serverPlay3D(FWReload1Sound,%obj.getPosition());
}

 package VulcanDeploying
{
  	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(%player.getMountedImage(0) $= VulcanImage.getID() && %slot $= 4 && %val)
		{
		if ($Pref::Server::VulcanDeploy == 1){
		  %player.mountImage(VulcanDeployedImage,0);
		  %player.pushDatablock(DeployedArmor.getID());
		  %player.setVelocity("0 0 0");
		  }
		}     
		
		else if(%player.getMountedImage(0) $= VulcanDeployedImage.getID() && %slot $= 4 && %val)
		{
		  %player.mountImage(VulcanImage,0);
		  %player.popDatablock(DeployedArmor.getID());
		}
		Parent::onTrigger(%this, %player, %slot, %val);
	}

		function servercmdDropTool(%client,%slot)
	{
		if(%client.player.getMountedImage(0) $= VulcanDeployedImage.getID())
		{
		  %client.player.unmountImage(0);
		  %client.player.popDatablock(DeployedArmor.getID());
		}
		return Parent::servercmdDropTool(%client,%slot);
	}
};	
ActivatePackage(VulcanDeploying);	